code	segment	'code'
	assume	cs:code,ds:code

	org	100h

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	near ptr init		; jump to install routine/old handler
	dw	0

new10:	cmp	ax,3			; setting mode 3?
	jne	start

	pushf				; call old handler
	push	cs
	call	start
	
	push	ax			; save registers
	push	bx
	push	cx
	push	dx
	push	bp
	push	ds
	push	es

	mov	ax,1130h		; get font info
	mov	bh,3			; 8x8 font, low 128 chars
	int	10h
	xor	ax,ax
	mov	ds,ax
	mov	word ptr ds:[10ch],bp	; point INT 43h to 8x8 font
	mov	word ptr ds:[10eh],es

	pop	es			; restore registers
	pop	ds
	pop	bp
	pop	dx
	pop	cx
	pop	bx
	pop	ax

	iret

init:	mov	ax,3510h		; create jump to old handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new10		; hook into chain
	mov	ah,25h
	int	21h

	mov	es,envseg		; free environment segment
	mov	ah,49h
	int	21h

	mov	dx,0014h		; terminate leaving DX paras resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
